varying vec3 normal;
varying vec3 lightDir;
varying vec3 viewDir;

uniform sampler2D colourMap;

void main(void)
{
	vec3 lightVec = normalize(lightDir);
	vec3 viewVec = normalize(viewDir);
	vec3 norm = normalize(normal);

	// ambient
	vec4 intensity = gl_LightSource[0].ambient;
	
	// diffuse
	intensity += gl_LightSource[0].diffuse*max(0.0,dot(lightVec,norm));
	
	// spec
	vec3 reflectVec = reflect(-lightVec,norm); 	// create reflect view direction
	float spec = pow(clamp(dot(reflectVec,viewVec),0.0,1.0),60.0);
	intensity += gl_LightSource[0].specular*spec;
	
	vec4 col = texture2D(colourMap,gl_TexCoord[0].st) * intensity;
	gl_FragColor = vec4(col.rgb,1.0);
}