// Taken primarily from Randi Rost's implementation (c) 3DLabs

varying vec3 lightDir; 	  // interpolated surface local coordinate light direction 
varying vec3 viewDir;     // interpolated surface local coordinate view direction

attribute vec3 Tangent;
attribute vec3 Binormal;

void main (void)
{
	vec3 v; //used as temporary variable
	vec3 lightVec = vec3(gl_ModelViewMatrix  * gl_LightSource[0].position);
	
	// cause we have to...
	 gl_TexCoord[0] = gl_MultiTexCoord0;
	 gl_Position = ftransform();
	 
	// Transform the input vectors
	vec3 t = normalize(gl_NormalMatrix * Tangent);
   	vec3 b = normalize(gl_NormalMatrix * Binormal);
   	vec3 n = normalize(gl_NormalMatrix * gl_Normal);

   	// Transform light position into surface local coordinates
	vec3 pos = vec3(gl_ModelViewMatrix * gl_Vertex);
	lightVec = lightVec - pos;
   	v.x = dot(lightVec, t);
   	v.y = dot(lightVec, b);
	v.z = dot(lightVec, n);
	lightDir = normalize(v);
	
	pos = -pos;
	v.x = dot(pos, t);
	v.y = dot(pos, b);
	v.z = dot(pos, n);
	viewDir = normalize(v);
}
